/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-09-02 13:20
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const ll MAXN = 1500 + 9;
/* const ll MAXN = 3000 + 9; */
/* const ll MAXM = MAXN; */
const ll INF = 1LL << 60;

/* int n, k; */
vector<vector<int>> g;
vector<int> mt;
vector<bool> used;

bool try_kuhn(int v) {
    if (used[v])
        return false;
    used[v] = true;
    for (int to : g[v]) {
        if (mt[to] == -1 || try_kuhn(mt[to])) {
            mt[to] = v;
            return true;
        }
    }
    return false;
}

int kuhn(int n) {
    int cnt = 0;
    mt.assign(MAXN, -1);
    for (int v = 0; v < n; ++v) {
        used.assign(n, false);
        cnt += try_kuhn(v);
    }
    return cnt;
}


ll M, N, K;
int trySocket(int soc){
    int a = M+1, b = M+2;
    g[a] = g[soc];
    g[b] = g[soc];
    /* assert(ml[a] == -1 and ml[b] == -1); */
    /* assert(mt[a] == -1 and mt[b] == -1); */
    used.assign(MAXN, false);
    int x = try_kuhn(a);
    used.assign(MAXN, false);
    int y = try_kuhn(b);
    return x + y;
}


void solve(){
    // Code goes here ...
    cin >> M >> N >> K;

    g = vector<vector<int>>(MAXN, vector<int>());

    vector<vector<int>> &sockets = g;
    int soc, dev;
    /* const int deviceOffset = 1500 + 5; */
    R(i, K){
        cin >> soc >> dev;
        sockets[soc].push_back(dev);
    }

    int res = kuhn(M+1);

    vector<int> backup_m(mt);
    int add = 0;
    R(i, M+1){
        add = max(add, trySocket(i));
        mt = backup_m;
    }

    cout << res + add << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    /* cin >> T; */
    while(T--)
        solve();

    return 0;
}
        
